<template>
  <div v-if="isLoaded">
    <div v-if="isLoggedin">
      <SIcon name="log-in" class="inline-block h-8 w-8 text-ec-status-success" />
      User logged in
    </div>
    <SButton class="text-right" v-if="!isLoggedin" href="/login">Log in</SButton>
  </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';
import SIcon from '../common/SIcon.vue';
import SButton from '../common/SButton.vue';
import { getSelfDescriptions } from '../../services/federatedCatalogue';
const isLoggedin = ref(false);
const isLoaded = ref(false);
const keycloakToken = ref<string | null>(null);

const emit = defineEmits<{
  (e: 'is-logged-in', loginStatus: boolean, keycloakToken?: string): void;
}>();

const redirectToLogin = () => {
  isLoggedin.value = false;
  setTimeout(() => {
    window.location.href = '/login';
  }, 3000);
};

onMounted(async () => {
  keycloakToken.value = window.localStorage.getItem('KEYCLOAK_ACCESS_TOKEN');
  if (!keycloakToken.value) {
    emit('is-logged-in', false);
    redirectToLogin();
  }
  try {
    await getSelfDescriptions(keycloakToken.value!);
    isLoggedin.value = true;
    emit('is-logged-in', true, keycloakToken.value!);
  } catch {
    emit('is-logged-in', false);
    redirectToLogin();
  } finally {
    isLoaded.value = true;
  }
});
</script>
